<template>
  <div :id="id">
    <template
      v-if="field.displayType == Constant.PermissionType_HIDDEN || field.textType == 'hidden'"
    >
      <!-- 隐藏 TODO:注意，隐藏时不应该有hidden的field存在，有安全问题，以后要改过来：Jarod -->
      <input type="hidden" v-model="field.value" />
      <a class="mint-cell" v-if="field.mobile && field.hiddenValue">
        <div class="mint-cell-wrapper">
          <div class="mint-cell-title">
            <span class="mint-cell-text">{{field.discript?field.discript:field.name}}</span> 
          </div> 
          <div class="mint-cell-value">
            <span>{{field.hiddenValue}}</span>
          </div> 
        </div>
      </a>
    </template>
    
    <!--只读-->
    <template v-else-if="field.textType == 'readonly' || field.displayType == Constant.PermissionType_READONLY || field.displayType == Constant.PermissionType_DISABLED">
      <template v-if="field.readOnlyShowValOnly">
        <!-- 只读（文本模式） -->
        
      </template>
      <template v-else>
        <!-- 只读（控件模式） -->
         <!--弹出框形式-->
        <div class="wrap" v-if="field.openType == '3'">
          <div class="wrap-left">
            {{field.discript?field.discript:field.name}}
          </div>
          <div class="wrap-right" @click="openDialog">
            <img src="../assets/images/word.png">
          </div>
        </div>
        <!--嵌入形式-->
        <div class="wrap-embed" v-else-if="field.openType == '1'">
          <div class="wrap-left">
            {{field.discript?field.discript:field.name}}
          </div>
          <div class="arrow" style="height:530px;">
            <iframe
              v-if="pdfUrl"
              ref="mainFrame"
              style="border:none"
              width="100%"
              height="100%"
              frameborder="0"
              allowtransparency="true" 
              noresize="noresize"
              :src="pdfUrl"
            ></iframe>
          </div>
        </div>
        <mt-popup
          v-model="popupVisible"
          position="bottom"
          style="height:85%;width:100%">
          <div class="head-name">
            <span class="file-name">{{(field.discript?field.discript:field.name).concat(".pdf")}}</span>
          </div>
          <div style="width:100%;height:calc(100% - 35px);overflow-y:auto;">  
            <iframe
              v-if="pdfUrl"
              ref="mainFrame"
              style="border:none"
              width="100%"
              height="100%"
              frameborder="0"
              allowtransparency="true" 
              noresize="noresize"
              :src="pdfUrl"
            ></iframe>
          </div>
        </mt-popup>
      </template>
    </template>

    <template v-else-if="field.displayType == Constant.PermissionType_MODIFY">
      <!-- 可编辑 -->
      <!--弹出框形式-->
      <div class="wrap" v-if="field.openType == '3'">
        <div class="wrap-left">
          {{field.discript?field.discript:field.name}}
        </div>
        <div class="wrap-right" @click="openDialog">
          <img src="../assets/images/word.png">
        </div>
      </div>
      <!--嵌入形式-->
      <div class="wrap-embed" v-else-if="field.openType == '1'">
        <div class="wrap-left">
          {{field.discript?field.discript:field.name}}
        </div>
        <div class="arrow" style="height:530px;">
          <iframe
            v-if="pdfUrl"
            ref="mainFrame"
            style="border:none"
            width="100%"
            height="100%"
            frameborder="0"
            allowtransparency="true" 
            noresize="noresize"
            :src="pdfUrl"
          ></iframe>
        </div>
        <!-- <div class="arrow" >
          <div v-bind:class="[currentPage==1?'previous_disabled':'previous']" @click="changePdfPage(0)"><img src="../assets/images/left_pre.png" /></div>
          <span>{{currentPage}} / {{pageCount}}</span>
          <div v-bind:class="[currentPage==pageCount?'next_disabled':'next']" @click="changePdfPage(1)"><img src="../assets/images/right_next.png" /></div>
        </div>
        <div class="pdf-con" 
          @touchstart="touchstart"
          @touchmove="touchmove"
          @touchend="touchend(isembed)"
        >
          <div class="pdf-w">
            <pdf 
              ref="pdfs"
              v-show="pdfUrl" 
              :src="pdfUrl"
              :page="currentPage"
              @num-pages="pageCount=$event" 
              @page-loaded="currentPage=$event" 
              @loaded="loadPdfHandler">
            >
            </pdf>
          </div>
        </div> -->
      </div>
   
      <mt-popup
        v-model="popupVisible"
        position="bottom"
        style="height:85%;width:100%">
        <div class="head-name">
          <span class="file-name">{{(field.discript?field.discript:field.name).concat(".pdf")}}</span>
        </div>
        <div style="width:100%;height:calc(100% - 35px);overflow-y:auto;">  
          <iframe
            v-if="pdfUrl"
            ref="mainFrame"
            style="border:none"
            width="100%"
            height="100%"
            frameborder="0"
            allowtransparency="true" 
            noresize="noresize"
            :src="pdfUrl"
          ></iframe>
            <!-- @touchstart="touchstart"
            @touchmove="touchmove"
            @touchend="touchend">
          <pdf 
            ref="pdf"
            v-if="pdfUrl" 
            :src="pdfUrl"
            :page="currentPage"
            @num-pages="pageCount=$event" 
            @page-loaded="currentPage=$event" 
            @loaded="loadPdfHandler">
          >
          </pdf>
          <div class="arrow" >
            <div v-bind:class="[currentPage==1?'previous_disabled':'previous']" @click="changePdfPage(0)"><img src="../assets/images/left_pre.png" /></div>
            <span>{{currentPage}} / {{pageCount}}</span>
            <div v-bind:class="[currentPage==pageCount?'next_disabled':'next']" @click="changePdfPage(1)"><img src="../assets/images/right_next.png" /></div>
          </div> -->
        </div>
      </mt-popup>
    </template>
  </div>
</template>

<script>
import pdf from 'vue-pdf'
import Constant from "@/Constant.js"
import controlHidden from "@/assets/js/controlHidden.js"
export default {
  name: "o-word",
  props: ["id"],
  computed: {
    field: function() {
      let formData = this.$parent.findField(this.id);
      if(formData.openType == '1') {
        this.setEmbedPdf(formData['data-file-name'],formData['data-full-path']);
      }
      return this.$parent.findField(this.id);
    }
  },
  components: {
    pdf,
  },
  mounted(){
    this.$nextTick(()=>{
      let field = this.field;
      if(field.isHideType) {
        let id = this.id,
          formShowType = field.formShowType;
        controlHidden({id, field, formShowType})
      }
    })
  },
  data: function() {
    return {
      Constant,
      pdfUrl:'',
      popupVisible: false,

      currentPage: 0, // pdf文件页码
      pageCount: 0, // pdf文件总页数
      //fileType: 'pdf', // 文件类型
      src: '', // pdf文件地址
      pageX:'', 
      pageY:'', 
      initX:'', 
      initY:'', 
      isTouch:false,
      start: [],
      scaleLength:'',
      touchespageX:'',
      touchespageY:'',
      scale:100,
      touchMoveX:'',
      touchMoveY:'',
      valLength:'',
      now:'',
      startVal:'',
      endVal:'',
      isZoom:false,
      isembed:true,
    };
  },
  methods: {
    setEmbedPdf(value,path) {
      let id = value.split('.')[0];
      this.$api.readPDF(id,path, {
        onSucess: response => {
            let pdfUrl = obpmConfig.obpmFilePath + "/" + response.data.data
            let pdfPath = "";
            let statiContextPath = obpmConfig.statiContextPath;
            if(statiContextPath) { //5.0 trunk
              pdfPath = obpmConfig.statiContextPath + '/mobile/pdf/web/viewer.html?file=' + pdfUrl
            }else { //4.4 stable
              pdfPath = obpmConfig.obpmFilePath + '/mobile/pdf/web/viewer.html?file=' + pdfUrl
            }
            this.pdfUrl = pdfPath;
        }
      });
    },
    touchstart(e) {
			this.pageX = e.targetTouches[0].pageX;
			this.pageY = e.targetTouches[0].pageY;
			this.initX = e.target.offsetLeft;
      this.initY = e.target.offsetTop;
			//记录初始 一组数据 作为缩放使用
      if (e.touches.length >= 2) { //判断是否有两个点在屏幕上
        this.start = e.touches; //得到第一组两个点
        this.isTouch = true;
			}
			this.isTouch = true;
    },
    touchmove(e) {
			// 一根 手指 执行 目标元素移动 操作
			if (e.touches.length == 1 && this.isTouch) {
				//移动目标的 X Y 坐标
				this.touchMoveX = e.targetTouches[0].pageX,
				this.touchMoveY = e.targetTouches[0].pageY;
				//设置当前点击元素的 top left 定位值
				e.target.style.left = parseInt(this.touchMoveX) - parseInt(this.pageX) + parseInt(this.initX) + "px";
        e.target.style.top = parseInt(this.touchMoveX) - parseInt(this.pageY) + parseInt(this.initY) + "px";
			}

			// 2 根 手指执行 目标元素放大操作
			if (e.touches.length >= 2 && this.isTouch) {
        e.preventDefault();
        this.now = e.touches;
        let x = this.now[1].pageX - this.now[0].pageX;
        let y = this.now[1].pageY - this.now[0].pageY;
        this.startVal = Math.sqrt((x * x) + (y * y));
        let z = this.start[1].pageX - this.start[0].pageX;
        let j = this.start[1].pageY - this.start[0].pageY;
        this.endVal = Math.sqrt((z * z) + (j * j));
        this.valLength = this.startVal/this.endVal;
        this.isZoom = true;
      }
    },

    touchend(isembed) {
      if (this.isTouch) {
				this.isTouch = false;
      }
      if(isembed) {
        if(this.valLength>=1 && this.isZoom) {
          this.scale += 15;
          this.$refs.pdfs.$el.style.width = parseInt(this.scale) + "%";
          this.isZoom = false
        }else if(this.valLength<1 && this.isZoom){
          if (this.scale == 100) {
            return;
          }
          this.scale += -15;
          this.$refs.pdfs.$el.style.width = parseInt(this.scale) + "%";
          this.isZoom = false
        }
      }else {
        if(this.valLength>=1 && this.isZoom) {
          this.scale += 15;
          this.$refs.pdf.$el.style.width = parseInt(this.scale) + "%";
          this.isZoom = false
        }else if(this.valLength<1 && this.isZoom){
          if (this.scale == 100) {
            return;
          }
          this.scale += -15;
          this.$refs.pdf.$el.style.width = parseInt(this.scale) + "%";
          this.isZoom = false
        }
      }


      
    },

    // 改变PDF页码,val传过来区分上一页下一页的值,0上一页,1下一页
    changePdfPage (val) {
      if (val === 0 && this.currentPage > 1) {
        this.currentPage--
      }
      if (val === 1 && this.currentPage < this.pageCount) {
        this.currentPage++
      }
    },
    // pdf加载时
    loadPdfHandler (e) {
      console.log(e);
      this.currentPage = 1 // 加载的时候先加载第一页
    },

    openDialog() {
      //let path = this.field.fileInfo +''+ this.field.fileInfo;
      this.popupVisible = true;
      let id = this.field['data-file-name'].split('.')[0];
      let path = this.field['data-full-path'];
      this.dialogVisible = true;
      this.$api.readPDF(id,path, {
        onSucess: response => {
          let pdfUrl = obpmConfig.obpmFilePath + "/" + response.data.data
          let pdfPath = "";
          let statiContextPath = obpmConfig.statiContextPath;
          if(statiContextPath) { //5.0 trunk
            pdfPath = obpmConfig.statiContextPath + '/mobile/pdf/web/viewer.html?file=' + pdfUrl
          }else { //4.4 stable
            pdfPath = obpmConfig.obpmFilePath + '/mobile/pdf/web/viewer.html?file=' + pdfUrl
          }
          this.pdfUrl = pdfPath;
        }
      });
    },
    handleClose() {
      this.dialogVisible = false;
    },
  }
}
</script>
